import process from "./process"
import jsonp from "./jsonp"
import xhr from "./xhr"

function beforeAjax(options) {
	if (_.isFunction(options.switch)) options.switch(true)
}

function afterAjax(options) {
	if (_.isFunction(options.switch)) options.switch(false)
}

export default function (options) {
	if (beforeAjax(options)) return
	options.success = (data, status) => {
		if (afterAjax(options)) return
		process(0)({data: data, status: status}, options)
	}
	options.fail = (status, errorType, describe) => {
		if (afterAjax(options)) return
		process(1)({status: status, errorType: errorType, describe: describe}, options)
	}
	
	if (_.toLower(options.dataType) === 'jsonp') jsonp(options)
	else xhr(options)
}