let jsonpCounter = 100
import {buildURL} from "../util"

export default function jsonp(options) {
	const jsonpCallbackName = options.jsonp + jsonpCounter++
	let called = false
	window[jsonpCallbackName] = data => {
		called = true
		options.success(data)
	}
	
	const script = document.createElement('script')
	script.type = 'text/javascript'
	const params = _.clone(options.data)
	params[options.jsonp] = jsonpCallbackName
	script.src = buildURL({
		url: options.url,
		params: params
	})
	document.head.appendChild(script)
	script.onload = function () {
		if (!called) {
			options.fail({
				message: 'jsonp 返回结果不合法',
			}, 'parsererror', {
				status: 200,
				readyState: 4,
			})
		}
		delete window[jsonpCallbackName]
		document.head.removeChild(script)
	}
	script.onerror = function () {
		options.fail({
			message: '请求拒绝访问！',
		}, '(failed)net::ERR_CONNECTION_REFUSED', {
			status: null
		})
		document.head.removeChild(script)
	}
}