function dealResponse(response) {
	const data = response.data || response
	const status = response.status || data.status
	const result = {...data, status}
	return _.pickBy(result, val => !_.isUndefined(val))
}

function successProcess(response, options) {
	const res = dealResponse(response)
	if (res.success && res.success !== 'false') {
		const data = res.data || res
		options.resolve(options.dataPath ? _.get(data, options.dataPath) : data)
	} else {
		const errText = (res.message || res.msg) ? (res.message || res.msg) : '暂无错误信息'
		options.reject(errText, res, _.pick(options, ['name', 'url']))
	}
}

function failProcess(errorInfo, options) {
	let errText = "ajax error"
	let errorType = errorInfo.errorType
	let info = errorInfo.status
	if (errorType === "error" && info.status === "404") errText = "404 不可用的路径"
	else if (errorType === "parsererror") {
		if (info.message || info.msg) errText = info.message || info.msg
		else if (info.response) errText = "JSON返回数据格式异常！"
		else errText = "服务器返回数据无法解析！"
	} else errText = "服务器异常！"
	
	options.reject(`${options.name}：` + errText, errorInfo)
}

export default function (target){
	return [successProcess, failProcess][target]
}