import buildInterface from './interface/index'
import {buildURL} from "./util"

export default class InterfaceProxy {
	constructor(configMap, globalOptions) {
		if (!_.isArray(globalOptions)) globalOptions = [globalOptions || {}]
		
		this.$globalOptions = globalOptions.reduce((pre, cur) => _.assign(_.clone(pre), cur), {})
		
		this.$configMap = configMap
		
		this.buildURL = buildURL
		
		_.forOwn(_.cloneDeep(configMap), (value, key) => this[key] = buildInterface(key, this))
	}
}