import {InterfaceDefaultOptions as defaultOpt} from "../defaultOptions"
import {getAjaxConfig} from "./ajaxConf"
import doAjax from "../ajax/index"


function buildInterface(key, proxy) {
	const selfOpt = proxy.$configMap[key]
	const globalOpt = _.assignWith(_.clone(proxy.$globalOptions), defaultOpt, (tar, src) => tar ? tar : src)
	const iConf = _.assign(globalOpt, selfOpt)
	
	const buildProxy = function (params, callback, errorCallback) {
		const options = getAjaxConfig(arguments, iConf)
		const agent = new Promise((resolve, reject) => {
			options.resolve = function () {
				resolve.call(this, ...arguments)
				options.callback && options.callback.call(this, ...arguments)
			}
			options.reject = function () {
				reject.call(this, ...arguments)
				options.errorCallback && options.errorCallback.call(this, ...arguments)
			}
			
			proxy[key].reject = callback => {
				reject()
				callback && callback()
				options.callback = options.errorCallback = _.noop
			}
		})
		
		agent.catch = ecb => {
			agent.then(null, ecb)
			return agent
		}
		
		agent.switch = (tar, key) => {
			options.switch = val => tar[key] = val
			return agent
		}
		
		setTimeout(doAjax, 0, options)
		
		return agent
	}
	
	buildProxy.$options = iConf
	
	buildProxy.url = iConf.url || iConf.origin + iConf.pathname
	
	return buildProxy
}

export default buildInterface